// This program is copyright VUW.
// You may not distribute it in any way without permission.

/* Code for COMP102 - 2019T2, Mid-Term Test 2
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;

/**
 * Question 4. Event-Driven Input                                [12 marks]
 * 
 * Complete the class below so that it allows the user to draw
 * filled and unfilled squares with different sizes on the graphics
 * pane.
 * 
 * The program should have one button which allows the user to swap
 * between “filled” and “unfilled”, and one slider which allows the user
 * to set the size of the square to be drawn.
 * 
 * When the user releases the mouse at a position on the window, the
 * program should draw a filled or unfilled square of the specified size
 * centered at that position.
 * 
 * Hint: The addSlider method requires a name, a minimum value,
 *       a maximum value, an initial value and a method to call.
 *       (Use a min of 1, a max of 100, and an initial value of 20)
 */
public class Program4
{
    // fields
    /*# YOUR CODE HERE */
    private double size = 20; // size of the squares
    private boolean filled = true;
    /*# END OF YOUR CODE */
    
    /**
     * Change whether the squares are filled or not.
     * 
     * If they are current filled, this should change
     * it to unfilled. If they are currently unfilled
     * it should change it to filled.
     */
    public void setFill(){
        /*# YOUR CODE HERE */
        this.filled = !this.filled;
        /*# END OF YOUR CODE */
        
    }
    
    /**
     * Change the size of the shapes being drawn.
     * 
     * This should just update the size.
     */
    public void setSize (double v){
        /*# YOUR CODE HERE */
        this.size = v;
        /*# END OF YOUR CODE */
        
    }
    
    /**
     * Handle the mouse events.
     * 
     * If the mouse is released, this should draw a filled
     * or unfilled square, centered at (x,y).
     */
    public void doMouse(String action, double x, double y){
        /*# YOUR CODE HERE */
        if ( action.equals("released")){
            if (this.filled){
                UI.fillRect(x-size/2, y-size/2, size, size);
            } else {
                UI.drawRect(x-size/2, y-size/2, size, size);
            }
        }
        /*# END OF YOUR CODE */
        
    }
    
    /*********************************************
     * YOU CAN IGNORE EVERYTHING BELOW THIS LINE *
     *********************************************/
    public void setupGUI() {
        UI.initialise();
        UI.addButton("Filled/Unfilled", this::setFill);
        UI. addSlider ("size", 1, 100, 20, this::setSize );
        UI.setMouseListener(this :: doMouse);
        UI.setWindowSize(500,500);
        UI.setDivider(0.0);
    }
    
    public static void main(String[] args) {
        new Program4().setupGUI();
    }
}
